/// Impulse type
enum ImpulseType { iir, fir }

/// Sampling rate
enum SamplingRate { freq250hz, freq500hz }

/// DC block (== DcNotch
enum DcBlock { off, on }

enum BandStop { off, bsf50, bsf60 }

enum HighPass { off, hpf01, hpf05 }

enum LowPass { off, lpf40, lpf100 }

/// Adaptive filter
enum Adaptive { off, on }

final filterTypes = [
  ...DcBlock.values.where((e) => !e.name.endsWith('off')),
  ...BandStop.values.where((e) => !e.name.endsWith('off')),
  ...HighPass.values.where((e) => !e.name.endsWith('off')),
  ...LowPass.values.where((e) => !e.name.endsWith('off')),
  ...Adaptive.values.where((e) => !e.name.endsWith('off')),
];

extension SamplingRateToValue on SamplingRate {
  int get value => this == SamplingRate.freq250hz ? 250 : 500;
}
