import 'package:healthrian_common_support/healthrian_common_support.dart';

class FIRFilter extends FilterInterface {
  FIRFilter({required this.impulseResponse})
      : length = impulseResponse.length,
        delayLine = List.filled(impulseResponse.length, 0);

  final List<double> delayLine;
  final List<double> impulseResponse;
  final int length;
  int count = 0;

  double apply(double input) {
    if (length == 0) return input;
    delayLine[count] = input;
    double result = 0.0;
    int index = count;
    for (int i = 0; i < length; i++) {
      result += impulseResponse[i] * delayLine[index--];
      if (index < 0) index = length - 1;
    }
    if (++count >= length) count = 0;
    return result;
  }

  @override
  int get delay => impulseResponse.length ~/2;
}
